<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>
    <!-- font awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

    <title>Dice History</title>
</head>

<body>
    <div class="container">
        <div class="text-center">
            <h3>F200 - LỊCH SỬ ĐỔ XÚC XẮC</h3>
        </div>
        <div class="container jumbotron">
            <h6>Thông tin người chơi:</h6>
            <div class="row">
                <div class="col-4 form-group ">
                    <label for="inp-username" style="font-weight: 500;">Username</label>
                    <input type="text" name="" id="inp-username">
                </div>
                <div class="col-4 form-group">
                    <label for="inp-firstname" style="font-weight: 500;">Firstname</label>
                    <input type="text" name="" id="inp-firstname">
                </div>
                <div class="col-4 form-group">
                    <label for="inp-lastname" style="font-weight: 500;">Lastname</label>
                    <input type="text" name="" id="inp-lastname">
                </div>
            </div>
        </div>
        <div class="div-data-table">
            <table id="dice-history-table" class="table table-bordered table-hover table-striped table-info">
                <thead>
                    <tr>
                        <td class="col-4">Lần chơi</td>
                        <td class="col-8">Kết quả</td>
                    </tr>
                </thead>
            </table>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gUserDataObj = {
        userName: "",
        firstName: "",
        lastName: ""
    };
    var gDataDiceHistoryObj = [];
    var gPlayerDataTable = $("#dice-history-table").DataTable({
        columns: [
            { data: "game" },
            { data: "dices" },

        ]
    })


    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vCurrentURL = window.location.href;
        getDataFromURL(vCurrentURL);
        loadUserDataIntoForm(gUserDataObj);
        loadUserDiceHistoryIntoTable(gUserDataObj.userName);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy querySring từ URL của trang:
    function getDataFromURL(paramCurrentURL) {
        var vNewUrl = new URL(paramCurrentURL);
        //get parameters:
        var vUsername = vNewUrl.searchParams.get("user_name");
        var vFirstname = vNewUrl.searchParams.get("first_name");
        var vLastname = vNewUrl.searchParams.get("last_name");

        gUserDataObj.userName = vUsername
        gUserDataObj.firstName = vFirstname
        gUserDataObj.lastName = vLastname
        console.log(gUserDataObj)
    }
    //ham load user data into form
    function loadUserDataIntoForm(paramUserData) {
        $("#inp-username").val(paramUserData.userName);
        $("#inp-firstname").val(paramUserData.firstName);
        $("#inp-lastname").val(paramUserData.lastName);
    };
    //load user dice history into table:
    function loadUserDiceHistoryIntoTable(paramUserName) {
        $.ajax({
            url: gBASE_URL + "/dice-history?username=" + paramUserName,
            type: "GET",
            success: function (paramRes) {
                for (var bI = 0; bI < paramRes.dices.length; bI++) {
                    var bDice = { 'game': bI + 1, "dices": paramRes.dices[bI] }
                    gDataDiceHistoryObj.push(bDice);
                    
                };
                loadDataDiceHistoryIntoTable(gDataDiceHistoryObj)
            },
            error: function (paramError) {
                console.log(paramError.responseText)
            }
        });
    };


    //hàm load data into table: 
    function loadDataDiceHistoryIntoTable(paramDataObj) {
        console.log(paramDataObj)
        gPlayerDataTable.clear();
        gPlayerDataTable.rows.add(paramDataObj);
        gPlayerDataTable.draw();
    }
</script>

</html>